=== debian/changelog ===
oomox (1.12.5.3-0.1~mx19+1) mx; urgency=medium

  * Intitial packaging.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 22 Jan 2020 15:32:54 -0800
