=== debian/control ===
Source: oomox
Section: x11
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
Build-Depends: debhelper (>= 10)
Standards-Version: 4.1.3
Homepage: https://github.com/themix-project/oomox

Package: oomox
Architecture: all
Depends: 
 gir1.2-gdkpixbuf-2.0,
 gir1.2-glib-2.0,
 gir1.2-gtk-3.0,
 gir1.2-pango-1.0,
 gtk2-engines,
 gtk2-engines-murrine,
 gtk2-engines-pixbuf,
 libglib2.0-bin,
 libgtk-3-0,
 libgtk-3-bin,
 libgtk-3-common,
 libsass1 | libsass0,
 librsvg2-bin,
 libxml2-utils,
 optipng,
 parallel,
 python3-gi,
 python3-pil,
 python3-pillow,
 python3-pystache,
 python3-yaml,
 sed,
 sassc,
 ruby-sass,
 x11-xserver-utils
Suggests: archdroid-icon-theme,
 breeze-icon-theme,
 gnome-colors-icon-theme,
 imagemagick,
 inkscape,
 oomox-gtk-theme,
 oomoxify
Description: Oomox theme designer
 Graphical application for generating different color variations of Oomox
 (Numix-based), Materia (ex-Flat-Plat) and Arc themes (GTK2, GTK3, Cinnamon,
 GNOME, Openbox, Xfwm), Archdroid, Gnome-Color, Numix, Papirus and Suru++ icon
 themes. Has a hack for HiDPI in gtk2.
