=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --enable-gtk3
